#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1600four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four16004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four16004xi = {
                1:'1000x-1234y187z',
                2:'1001x-548y1120z',
                3:'1039x-500y1109z',
                4:'1046x-810y898z',
                5:'1064x-1182y171z',
                6:'1073x-449y1097z',
                7:'108x-306y1566z',
                8:'1095x-759y884z',
                9:'1106x-396y1085z',
                10:'111x-76y1594z',
                11:'1126x-1126y155z',
                12:'1135x-340y1074z',
                13:'1141x-706y871z',
                14:'1162x-283y1062z',
                15:'1184x-1066y139z',
                16:'1184x-649y857z',
                17:'1186x-224y1050z',
                18:'1206x-163y1038z',
                19:'1223x-100y1025z',
                20:'1224x-590y844z',
                21:'1237x-36y1013z',
                22:'1239x-1003y123z',
                23:'1261x-528y830z',
                24:'1291x-938y107z',
                25:'129x-78y1592z',
                26:'130x-315y1563z',
                27:'1339x-869y91z',
                28:'1375x-493y868z',
                29:'1384x-799y75z',
                30:'1424x-725y59z',
                31:'1461x-650y43z',
                32:'147x-79y1591z',
                33:'1493x-573y27z',
                34:'1521x-494y11z',
                35:'153x-322y1559z',
                36:'162x-1550y360z',
                37:'165x-78y1589z',
                38:'177x-327y1556z',
                39:'184x-75y1587z',
                40:'202x-330y1552z',
                41:'202x-71y1585z',
                42:'221x-65y1583z',
                43:'228x-332y1548z',
                44:'240x-57y1580z',
                45:'244x-1543y344z',
                46:'254x-332y1544z',
                47:'258x-47y1578z',
                48:'262x-636y1444z',
                49:'276x-35y1575z',
                50:'281x-330y1539z',
                51:'293x-22y1572z',
                52:'301x-635y1437z',
                53:'309x-326y1535z',
                54:'309x-7y1569z',
                55:'325x-1531y329z',
                56:'337x-320y1530z',
                57:'340x-631y1430z',
                58:'365x-312y1526z',
                59:'380x-624y1422z',
                60:'392x-301y1521z',
                61:'406x-1515y313z',
                62:'420x-289y1516z',
                63:'420x-615y1415z',
                64:'427x-903y1249z',
                65:'448x-274y1511z',
                66:'461x-603y1408z',
                67:'475x-258y1505z',
                68:'479x-891y1239z',
                69:'485x-1495y297z',
                70:'501x-239y1500z',
                71:'501x-589y1400z',
                72:'527x-218y1494z',
                73:'532x-875y1229z',
                74:'541x-572y1392z',
                75:'552x-195y1488z',
                76:'564x-1470y282z',
                77:'575x-170y1482z',
                78:'580x-553y1384z',
                79:'584x-856y1218z',
                80:'590x-1099y1001z',
                81:'598x-143y1476z',
                82:'618x-531y1376z',
                83:'619x-115y1470z',
                84:'635x-834y1208z',
                85:'639x-84y1464z',
                86:'641x-1441y266z',
                87:'652x-1075y988z',
                88:'656x-506y1368z',
                89:'657x-52y1457z',
                90:'673x-17y1451z',
                91:'686x-809y1197z',
                92:'693x-478y1359z',
                93:'713x-1048y975z',
                94:'717x-1408y250z',
                95:'729x-449y1351z',
                96:'735x-780y1187z',
                97:'763x-416y1342z',
                98:'773x-1017y963z',
                99:'784x-749y1176z',
                100:'791x-1370y234z',
                101:'796x-382y1334z',
                102:'81x-1553y375z',
                103:'827x-344y1325z',
                104:'831x-714y1165z',
                105:'831x-982y950z',
                106:'856x-305y1316z',
                107:'863x-1329y218z',
                108:'876x-677y1154z',
                109:'884x-264y1306z',
                110:'888x-944y937z',
                111:'909x-220y1297z',
                112:'920x-637y1143z',
                113:'932x-1283y202z',
                114:'932x-175y1288z',
                115:'943x-903y924z',
                116:'953x-127y1278z',
                117:'95x-72y1595z',
                118:'962x-594y1131z',
                119:'971x-78y1269z',
                120:'986x-28y1259z',
                121:'996x-858y911z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600four4xi" usage = "target function for charge16004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1600four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1600FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1600FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1600FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1600FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1600FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four16004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1600FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1600FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1600FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four16004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four16004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1600FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1600FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1600FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    